package juliac.generated;

import java.util.ArrayList;
import org.objectweb.fractal.julia.control.lifecycle.ChainedIllegalLifeCycleException;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import org.scorware.tinfi.control.intent.Handler;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.scorware.tinfi.control.intent.IntentJoinPoint;
import org.objectweb.fractal.api.control.LifeCycleController;
import java.util.List;
import org.scorware.tinfi.control.intent.SCAIntentController;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin
 * @see org.objectweb.fractal.julia.UseComponentMixin
 * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin
 * @see org.scorware.tinfi.control.intent.LifeCycleIntentMixin
 */
public class SCAIntentControllerImpl implements Controller , Generated , SCAIntentController {
    /** 
     * Check that the component is stopped and then call overriden method.
     * @see org.scorware.tinfi.control.intent.LifeCycleIntentMixin#addHandler(org.scorware.tinfi.control.intent.Handler)
     */
    public void addHandler(Handler handler) throws IllegalLifeCycleException {
        if ((weaveableOptLC) != null) {
            String state = weaveableOptLC.getFcState();
            if (!(LifeCycleController.STOPPED.equals(state))) {
                throw new ChainedIllegalLifeCycleException(null , weaveableOptC , "The component is not stopped");
            } 
        } 
        addHandler$0(handler);
    }
    
    /** 
     * The {@link Component} interface of the component to which this controller
     * object belongs.
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableC
     */
    public Component weaveableC;
    
    /** 
     * Does nothing.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$2(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     *
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$1(final InitializationContext ic) throws InstantiationException {
        initFcController$2(ic);
    }
    
    /** 
     * The {@link LifeCycleController} interface of the component to which this
     * controller object belongs.
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#weaveableOptLC
     */
    public LifeCycleController weaveableOptLC;
    
    /** 
     * The {@link Component} interface of the component to which this controller
     * object belongs.
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableOptC
     */
    public Component weaveableOptC;
    
    /** 
     * Check that the component is stopped and then call overriden method.
     * @see org.scorware.tinfi.control.intent.LifeCycleIntentMixin#removeHandler(org.scorware.tinfi.control.intent.Handler)
     */
    public void removeHandler(Handler handler) throws IllegalLifeCycleException {
        if ((weaveableOptLC) != null) {
            String state = weaveableOptLC.getFcState();
            if (!(LifeCycleController.STOPPED.equals(state))) {
                throw new ChainedIllegalLifeCycleException(null , weaveableOptC , "The component is not stopped");
            } 
        } 
        removeHandler$0(handler);
    }
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        weaveableOptLC = ((LifeCycleController)(ic.getOptionalInterface("lifecycle-controller")));
        initFcController$0(ic);
    }
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.UseComponentMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
        weaveableC = ((Component)(ic.getInterface("component")));
        weaveableOptC = weaveableC;
        initFcController$1(ic);
    }
    
    /** 
     * Add an intent handler in the list managed by this controller.
     * 
     * @param handler  the intent handler to add
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#addHandler(org.scorware.tinfi.control.intent.Handler)
     */
    private void addHandler$0(Handler handler) {
        if ((handlers) == null) {
            handlers = new ArrayList<org.scorware.tinfi.control.intent.Handler> ();
        } 
        handlers.add(handler);
    }
    
    /** 
     * Return the array of intent handlers managed by this controller.
     * 
     * @param handler  the intent handler to add
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#listHandlers()
     */
    public Handler[] listHandlers() {
        if ((handlers) == null) {
            handlers = new ArrayList<org.scorware.tinfi.control.intent.Handler> ();
        } 
        return handlers.toArray(new Handler[handlers.size()]);
    }
    
    /** 
     * The {@link Controller#initFcController initFcController} method overriden
     * by this mixin.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     */
    private void initFcController$3(InitializationContext ic) throws InstantiationException {
    }
    
    private void addHandler$1(Handler handler) {
    }
    
    private void removeHandler$1(Handler handler) {
    }
    
    /** 
     * Remove an intent handler from the list managed by this controller.
     * 
     * @param handler  the intent handler to remove
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#removeHandler(org.scorware.tinfi.control.intent.Handler)
     */
    private void removeHandler$0(Handler handler) {
        if ((handlers) == null) {
            handlers = new ArrayList<org.scorware.tinfi.control.intent.Handler> ();
        } 
        handlers.remove(handler);
    }
    
    /** 
     * Handle the before part of the intent policy associated with the specified
     * intent join point.
     * 
     * @param ijp  the intent join point
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#before(org.scorware.tinfi.control.intent.IntentJoinPoint)
     */
    public void before(IntentJoinPoint ijp) {
        if ((handlers) != null) {
            ijp.setHandlers(handlers);
            ijp.before();
        } 
    }
    
    /** 
     * Handle the after part of the intent policy associated with the specified
     * intent join point.
     * 
     * @param ijp  the intent join point
     * @param t    the exception thrown by the before part or
     *             <code>null</code> if the before part returned normally
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#after(org.scorware.tinfi.control.intent.IntentJoinPoint,java.lang.Throwable)
     */
    public void after(IntentJoinPoint ijp, Throwable t) {
        if ((handlers) != null) {
            ijp.after(t);
        } 
    }
    
    /** 
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#handlers
     */
    private List<org.scorware.tinfi.control.intent.Handler>  handlers;
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.SCAIntentControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.scorware.tinfi.control.intent.SCAIntentControllerMixin org.objectweb.fractal.julia.UseComponentMixin org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin org.scorware.tinfi.control.intent.LifeCycleIntentMixin)";
    }
    
}

